# coding: utf-8

"""
    Kubeflow Pipelines on Tekton API

    This file contains REST API specification for Kubeflow Pipelines on Tekton. The file is autogenerated from the swagger definition.

    Contact: prashsh1@in.ibm.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from kfp_tekton_server_api.configuration import Configuration


class V1ResourceReference(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'key': 'V1ResourceKey',
        'name': 'str',
        'relationship': 'V1Relationship'
    }

    attribute_map = {
        'key': 'key',
        'name': 'name',
        'relationship': 'relationship'
    }

    def __init__(self, key=None, name=None, relationship=None, local_vars_configuration=None):  # noqa: E501
        """V1ResourceReference - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._key = None
        self._name = None
        self._relationship = None
        self.discriminator = None

        if key is not None:
            self.key = key
        if name is not None:
            self.name = name
        if relationship is not None:
            self.relationship = relationship

    @property
    def key(self):
        """Gets the key of this V1ResourceReference.  # noqa: E501


        :return: The key of this V1ResourceReference.  # noqa: E501
        :rtype: V1ResourceKey
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this V1ResourceReference.


        :param key: The key of this V1ResourceReference.  # noqa: E501
        :type key: V1ResourceKey
        """

        self._key = key

    @property
    def name(self):
        """Gets the name of this V1ResourceReference.  # noqa: E501

        The name of the resource that referred to.  # noqa: E501

        :return: The name of this V1ResourceReference.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this V1ResourceReference.

        The name of the resource that referred to.  # noqa: E501

        :param name: The name of this V1ResourceReference.  # noqa: E501
        :type name: str
        """

        self._name = name

    @property
    def relationship(self):
        """Gets the relationship of this V1ResourceReference.  # noqa: E501


        :return: The relationship of this V1ResourceReference.  # noqa: E501
        :rtype: V1Relationship
        """
        return self._relationship

    @relationship.setter
    def relationship(self, relationship):
        """Sets the relationship of this V1ResourceReference.


        :param relationship: The relationship of this V1ResourceReference.  # noqa: E501
        :type relationship: V1Relationship
        """

        self._relationship = relationship

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1ResourceReference):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, V1ResourceReference):
            return True

        return self.to_dict() != other.to_dict()
